(* $Id: CommandSemantics.ml 7643 2018-09-27 09:33:53Z sutre $ *)


(*
 * Semantics of program commands.
 *)


open Z3

let cst_to_z3_expr ctx c =
  Arithmetic.Integer.mk_numeral_i ctx c

let var_to_z3_expr ctx v =
  Arithmetic.Integer.mk_const_s ctx v

(*
 * expr_to_z3_expr ctx e returns a pair (pre, ze) where ze is the direct
 * translation of the expression e into a Z3 expression, and pre is a list of
 * side conditions (to forbid division by zero) for the evaluation of the
 * expression e.  This is needed because, according to the Z3 tutorial,
 * division by zero is allowed in Z3, but the result is not specified.
 *)
let rec expr_to_z3_expr ctx =
  failwith "expr_to_z3_expr: not implemented!"

let fwd_formula_of_assign ctx v e =
  failwith "fwd_formula_of_assign: not implemented!"

let bwd_formula_of_assign ctx v e =
  failwith "bwd_formula_of_assign: not implemented!"

let formula_of_skip ctx =
  failwith "formula_of_skip: not implemented!"

let formula_of_guard ctx (e, o, e') =
  failwith "formula_of_guard: not implemented!"

let fwd_formula ctx =
  function
  | Command.Assign (v, e) -> fwd_formula_of_assign ctx v e
  | Command.Guard p -> formula_of_guard ctx p
  | Command.Skip -> formula_of_skip ctx

let bwd_formula ctx =
  function
  | Command.Assign (v, e) -> bwd_formula_of_assign ctx v e
  | Command.Guard p -> formula_of_guard ctx p
  | Command.Skip -> formula_of_skip ctx
